/* RAFX - ext. Funktion zum Umpacken von gepackter Mail */

parse arg dir._temp,,
          log._file,,
          cmd._setfiledt,,
          def._zone,,
          def._outbound,,
          def._busyflags,,
          file._compress,,
          input

numeric digits 12

call prg_init_1
select
  when read_compress_cfg() <> 0
    then nop
  when read_arg() <> 0
    then nop
  when link.0 = 0
    then nop
  otherwise
    call proc_links
end

if dir._arc <> ''
  then
  do
    call directory dir._temp
    call sysrmdir dir._arc
  end

call directory dir._act

return status

/**********************************************************************/

/*======================================================================
  Rekursives Lschen des Inhalts eines Verzeichnisses
======================================================================*/

del_dir_rec: procedure

arg dir_name
dir_curr = directory()
call directory dir_name
call sysfiletree '*', 'data', 'tf', '*****', '**---'
do y = 1 to data.0
  call sysfiledelete subword(data.y, 4)
end
call sysfiletree '*', 'data', 'do'
do y = 1 to data.0
  call del_dir_rec data.y
  call sysrmdir data.y
end
call directory dir_curr

return

/**********************************************************************/

make_dir_arc: procedure expose (common_var)

if dir._arc <> ''
  then return 0

call directory dir._temp
dname = systempfilename('RAFX????.TMP')

select
  when dname = ''
    then status = 253
  when sysmkdir(dname) <> 0
    then status = 253
  otherwise
    dir._arc = directory(dname)
    call directory dir._act
end

return status

/**********************************************************************/

proc_links: procedure expose (common_var)

mask.0 = 4
mask.1 = 'HLO'
mask.2 = 'DLO'
mask.3 = 'CLO'
mask.4 = 'FLO'

day_ext = 'MO TU TH WE FR SA SU'
num_ext = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'

do l = 1 to link.0 until status <> 0

  parse var link._addr.l zone ':' net '/' node '.' point

  if zone = def._zone
    then dir._outbound = def._outbound
    else dir._outbound = def._outbound'.' || d2x(zone, 3)

  if point > 0
    then
    do
      dir._outbound  = dir._outbound || '\' || d2x(net, 4) || d2x(node, 4) || '.PNT'
      sfile = '\' || d2x(point, 8)
    end
    else sfile = '\' || d2x(net, 4) || d2x(node, 4)

  dir._outbound = translate(directory(dir._outbound))
  call directory dir._act
  if dir._outbound = ''
    then iterate                /* Outbound noch nicht angelegt */

    /* Flow-Files ermitteln */
  sfile = dir._outbound || sfile
  f = 0
  do m = 1 to mask.0
    call sysfiletree sfile'.'mask.m, 'data', 'fo'
    do y = 1 to data.0
      f = f +1
      flow_file.f = data.y
    end
  end
  if f = 0
    then iterate            /* Keine Flow-Files fr den Link vorhanden */
  flow_file.0 = f

  call proc_links_100       /* Busy-Flag erstellen */

    /* Flow-Files einlesen */

  m = 0
  do f = 1 to flow_file.0
    if stream(flow_file.f, 'c', 'open read') <> 'READY:'
      then iterate f
    do while lines(flow_file.f) > 0
      data = linein(flow_file.f)
      select
        when abbrev(data, '^')
          then data = substr(data, 2)
        when abbrev(data, '#')
          then data = substr(data, 2)
        otherwise
      end
      if data = ''
        then iterate      /* Fehlerhafter Eintrag */
      data = translate(stream(data, 'c', 'query exists'))
      if data = ''
        then iterate      /* File nicht gefunden */
      parse value right(data, 4) with . '.' +1 t1 +2 t2

      select
        when wordpos(t1, day_ext) = 0
          then nop        /* Keine Endung fr Wochentag */
        when verify(t2, num_ext) > 0
          then nop        /* Keine 'nummerische' Endung */
        when \abbrev(data, dir._outbound)
          then nop        /* File im falschen Verzeichnis */
        otherwise
          a = identify_arc(data)

          select
            when a = 0
              then nop    /* File keine Archiv oder Packer nicht erkannt */
            when a = link._arc.l
              then nop    /* File braucht nicht umgepackt werden */
            when arc._ext_os.a = 0
              then nop    /* Kein Kommando frs Entpacken definiert */
            otherwise
              m = m +1    /* File mu umgepackt werden */
              mail.m = data
              mail._arc.m = a
          end
      end
    end
    call stream flow_file.f, 'c', 'close'
  end
  mail.0 = m


    /* Mail umpacken */
  if mail.0 > 0
    then
    do
      dest_arc = link._arc.l
      call wlog ': Packed Mail' link._addr.l '->' arc.dest_arc
      if make_dir_arc() <> 0
        then return status

      call directory dir._arc
      do m = 1 to mail.0
        a = mail._arc.m
        call wlog ':' arc.a 'Archive' mail.m

        if cmd._setfiledt <> ''
          then
          do
            parse value space(stream(mail.m, 'c', 'query datetime')) with,
                fdt._mm'-'fdt._dd'-'fdt._yy fdt._hr':'fdt._min':'fdt._sec
            if fdt._yy < 80
              then fdt._yyyy = fdt._yy +2000
              else fdt._yyyy = fdt._yy +1900
          end


        if execute_arc('@'replace_str(arc._ext_cmd.a, '%a', mail.m, '%f', '*.pkt')) = 0
          then
          do
            backup = systempfilename(dir._outbound'\RAFX????.BAK')
            call rename_file mail.m, backup
            if execute_arc('@'replace_str(arc._add_cmd.dest_arc, '%a', mail.m, '%f', '*.*')) <> 0
              then
              do
                call sysfiledelete mail.m
                call rename_file backup, mail.m
              end
              else
              do
                call sysfiledelete backup
                if cmd._setfiledt <> ''
                  then '@'replace_str(cmd._setfiledt, '[%yyyy]', fdt._yyyy,,
                                                      '[%yy]'  , fdt._yy  ,,
                                                      '[%mm]'  , fdt._mm  ,,
                                                      '[%dd]'  , fdt._dd  ,,
                                                      '[%hr]'  , fdt._hr  ,,
                                                      '[%min]' , fdt._min ,,
                                                      '[%sec]' , fdt._sec ,,
                                                      '[%file]', mail.m) '>nul'
              end
          end
        call del_dir_rec dir._arc
      end
    end

  if def._busyflags
    then call sysfiledelete busyflag    /* Busy-Flag lschen */

end


return status




  /* Busy-Flag erstellen */

proc_links_100:
if \def._busyflags
  then return
busyflag = sfile'.BSY'

flag = 0
do forever
  select
    when stream(busyflag, 'c', 'query exists') <> ''
      then nop
    when stream(busyflag, 'c', 'open write') <> 'READY:'
      then nop
    otherwise
      call stream busyflag, 'c', 'close'
      leave
  end
  if \flag
    then
    do
      call wlogq '+' link._addr.l 'busy ...'
      flag = 1
    end
  call syssleep 1
end
return

/**********************************************************************/

identify_arc: procedure expose (common_var)

arg file

res = 0

if stream(file, 'c', 'open read') = 'READY:'
  then
  do
    size = stream(file, 'c', 'query size')
    str_lead = charin(file,, arc._ilen_lead)
    str_trail = reverse(charin(file, max(1, size -arc._ilen_trail +1), arc._ilen_trail))
    call stream file, 'c', 'close'

    do a = arc.0 to 1 by -1 until res > 0
      select
        when arc._ident.a == ''
          then iterate
        when arc._ipos.a > 0
          then if pos(arc._ident.a, str_lead) = arc._ipos.a
            then res = a
        when pos(arc._ident.a, str_trail) = -arc._ipos.a
          then res = a
        otherwise
      end
    end
  end

return res

/**********************************************************************/

read_compress_cfg: procedure expose (common_var)

do y = 1 to 10 while stream(file._compress, 'c', 'open read') <> 'READY:'
  call syssleep 1
end
if y > 10
  then
  do
    status = 254
    return status
  end

parse value translate(charin(file._compress,, chars(file._compress)), ' ', '9'x) with cfgstr '1a'x
call stream file._compress, 'c', 'close'

m = 0

s_begin = 1
do l = 1 until rest == ''
  parse var cfgstr =(s_begin)data(crlf) +2 rest +1
  s_begin = s_begin +length(data) +2

  call charout, 'R:' format(l, 6) || cr

  parse var data keyword data ';' .
  if keyword = ''
    then iterate

  keyword = translate(keyword)
  if keyword = 'DOS' | keyword = 'OS2'
    then
    do
      os = keyword
      parse var data keyword data
      keyword = translate(keyword)
    end
    else = os = ''

  select
    when m = 0
      then
      do
        if keyword <> 'ARCHIVER'
          then iterate
        if words(data) <> 1
          then iterate
        arc.0 = arc.0 +1
        a = arc.0
        arc.a = translate(strip(data))
        arc._add_os.a = 0
        arc._ext_os.a = 0

        m = 1
      end

    when keyword = 'END'
      then if translate(data) = 'ARCHIVER'
        then m = 0

    when keyword = 'IDENT'
      then
      do
        parse value strip(data) with iofs','ihex
        if \datatype(iofs, 'w') |,
           \datatype(ihex, 'x') |,
           idata = ''
          then iterate

        a = arc.0
        arc._ident.a = x2c(ihex)
        ilen = length(arc._ident.a)
        if iofs < 0
          then
          do
            arc._ident.a = reverse(arc._ident.a)
            arc._ipos.a = iofs
            arc._ilen_trail = max(arc._ilen_trail, ilen -iofs)
          end
          else
          do
            arc._ipos.a = iofs +1
            arc._ilen_lead = max(arc._ilen_lead, ilen +iofs)
          end
      end

    when keyword = 'ADD'
      then
      do
        a = arc.0
        temp._cmd = word(data, 1)
        select
          when set_full_name('temp._cmd') = ''
            then flag = 0
          when os = 'OS2'
            then flag = 3
          when os = ''
            then flag = 2
          otherwise
            flag = 1
        end
        if flag >= arc._add_os.a
          then
          do
            arc._add_cmd.a = check_filename(temp._cmd) subword(data, 2)
            arc._add_os.a  = flag
          end
      end

    when keyword = 'EXTRACT'
      then
      do
        a = arc.0
        temp._cmd = word(data, 1)
        select
          when set_full_name('temp._cmd') = ''
            then flag = 0
          when os = 'OS2'
            then flag = 3
          when os = ''
            then flag = 2
          otherwise
            flag = 1
        end
        if flag >= arc._ext_os.a
          then
          do
            arc._ext_cmd.a = check_filename(temp._cmd) subword(data, 2)
            arc._ext_os.a  = flag
          end
      end

    otherwise

  end

end

do a = 1 to arc.0
  if arc._add_os.a > 0
    then arc._add_idx = arc._add_idx arc.a
    else arc._add_idx = arc._add_idx cr
end

return status

/**********************************************************************/

check_filename: procedure

arg fname

str = right(fname, 4)
select
  when str = '.COM' | str = '.EXE' | str = '.BAT'
    then nop
  when str = '.CMD'
    then fname = 'CALL' fname
  otherwise
    fname = 'CMD.EXE /c' fname
end

return fname

/**********************************************************************/

read_arg: procedure expose (common_var) input

input = translate(input)
l = 0
do y = 1 to words(input) by 2
  arc = wordpos(word(input, y +1), arc._add_idx)

  if arc > 0
    then
    do
      l = l +1
      link._addr.l = word(input, y)
      link._arc.l  = arc
    end
end
link.0 = l

return status

/**********************************************************************/

prg_init_1:

dir._act = translate(directory())

cr = '0d'x ; lf = '0a'x ; crlf = cr || lf
status = 0

arc.  = ''
arc.0 = 0
arc._ilen_lead  = 0
arc._ilen_trail = 0

link. = 0

dir._arc = ''


common_var = 'cr lf crlf'         ,
             'status'             ,
             'cmd.'               ,
             'dir.'               ,
             'temp.'              ,
             'file.'              ,
             'log.'               ,
             'arc.'               ,
             'def.'               ,
             'link.'              ,
             'mail.'              ,
             ''

return

/**********************************************************************/

execute_arc: procedure expose (common_var)

parse arg prg
call close_logfile
prg '>nul'
res = rc
call open_logfile
if res <> 0
  then
  do
    call wlog '# Archiver RC =' res
    call wlog '# Command "'prg'"'
  end

return res

/**********************************************************************/

/* Datum/Uhrzeit - Argumente in Logfile schreiben */

wlog: procedure expose log.

parse arg l1 l2
l2 = l1 right(subword(date(), 1, 2), 6, '0') time('n') 'RAFX' l2
say l2
if log._file <> ''
  then call lineout log._file, l2

return


/* Datum/Uhrzeit - Argumente nur auf Bildschirm ausgeben */

wlogq: procedure

parse arg l1 l2
l2 = l1 right(subword(date(), 1, 2), 6, '0') time('n') 'RAFX' l2
say l2

return

/**********************************************************************/

set_full_name: procedure expose (common_var)
arg fvar, opt
pf = value(fvar)

select
  when pf = ''
    then nop
  when opt = 'P'      /* Pfadname vervollstndigen */
    then
    do
      pf = s_directory(pf)
      if pf <> ''
        then call value fvar, pf
      call directory dir._act
    end
  when opt = 'F'      /* Filename vervollstndigen, wenn vorhanden */
    then
    do
      pf = translate(stream(pf, 'c', 'query exists'))
      if pf <> ''
        then call value fvar, pf
    end
  otherwise           /* Nur Pfad eines Files vervollstndigen,
                         File nicht testen */
    file = filespec('n', pf)
    path = s_directory(filespec('d', pf) || filespec('p', pf))
    if path <> ''
      then
      do
        pf = path'\'file
        call value fvar, pf
      end
      else pf = ''
    call directory dir._act
end

return pf

/**********************************************************************/

s_directory: procedure

arg y
select
  when right(y, 1) = ':'
    then y = y'\'
  when right(y, 2) <> ':\' & y <> '\'
    then y = strip(y, 't', '\')
  otherwise
end
return translate(strip(directory(y), 't', '\'))

/**********************************************************************/

replace_str: procedure

parse arg dest, .

do y = 2 to arg() by 2
  l = length(arg(y))
  do forever
    p = pos(translate(arg(y)), translate(dest))
    if p > 0
      then dest = insert(arg(y +1), delstr(dest, p, l), p -1)
      else leave
  end
end

return dest

/**********************************************************************/

open_logfile:

select
  when log._file = ''
    then nop
  when stream(log._file, 'c', 'open') <> 'READY:'
    then log._file = ''
  otherwise
    call stream log._file, 'c', 'seek <0'
end
return


close_logfile:

if log._file <> ''
  then call stream log._file, 'c', 'close'
return

/**********************************************************************/

rename_file: procedure

arg src, dest
'@rename' src filespec('n', dest) '>nul 2>nul'

return rc

/************************************************************************/

